/***************************************************************************
                          fractalcalculationthread.h  -  description
                             -------------------
    begin                : Son Mai 11 2003
    copyright            : (C) 2003 by Thomas Dreibholz
    email                : dreibh@exp-math.uni-essen.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef FRACTALCALCULATIONTHREAD_H
#define FRACTALCALCULATIONTHREAD_H

#include <qthread.h>
#include <qimage.h>
#include <qobject.h>

#include "fractalalgorithminterface.h"
#include "colorschemeinterface.h"
#include "fractalbuffer.h"


/**
  *@author Thomas Dreibholz
  */

class FractalCalculationThread : public QThread {
   public:
   FractalCalculationThread(QObject*                   parent,
                            FractalAlgorithmInterface* algorithm,
                            ColorSchemeInterface*      cs,
                            FractalBuffer*             buffer,
                            QImage*                    image,
                            unsigned int               progStep);
   ~FractalCalculationThread();
   void stop();

   private:
   void run();

   private:
   QObject                    *Parent;
   FractalAlgorithmInterface  *Algorithm;
   ColorSchemeInterface       *ColorScheme;
   FractalBuffer              *Buffer;
   QImage                     *Image;
   unsigned int               MaxIterations;
   unsigned int               ProgStep;
   bool                       Stop;
};

#endif
