/***************************************************************************
                          mandelbrot.h  -  description
                             -------------------
    begin                : Son Mai 11 2003
    copyright            : (C) 2003 by Thomas Dreibholz
    email                : dreibh@exp-math.uni-essen.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef MANDELBROT_H
#define MANDELBROT_H

#include <fractalalgorithminterface.h>
#include <complex>

/**
  *@author Thomas Dreibholz
  */

class Mandelbrot : public FractalAlgorithmInterface  {
   public: 
   Mandelbrot();
   ~Mandelbrot();
   const char* getName();
   const char* getSaveIdentifier();
   
   std::complex<double> defaultC1();
   std::complex<double> defaultC2();
   unsigned int calculatePoint(const unsigned int x,
                               const unsigned int y);

   private:
   static Mandelbrot* Registration;
};

#endif
